#include "common/utils.hpp"
#include "nodes/base/base.hpp"
#include "nodes/httpPush/httpPush.hpp"

namespace Node
{

void HttpPushNode::work()
{
    printf("HttpPush %s\n", name_.c_str());
    while (running_)
    {
        for (auto& input_buffer : input_buffers_)
        {
            std::shared_ptr<meta::MetaData> metaData;
            if (!input_buffer.second->try_pop(metaData))
            {
                continue;
            }
            // printf("Node %s get data from %s\n", name_.c_str(), input_buffer.first.c_str());
            // do something
            cv::Mat image = metaData->draw_image;
            std::string image_name = metaData->from + "_" + getTimeString() + ".jpg";
            cv::imwrite(image_name, image);
        }
    }
};

}   // namespace Node