#ifndef STREAMNODE_HPP__
#define STREAMNODE_HPP__

#include "nodes/base/base.hpp"
#include <opencv2/opencv.hpp>

namespace Node
{

class StreamNode : public BaseNode
{
public:
    StreamNode() = delete;
    StreamNode(const std::string& name) : BaseNode(name, NODE_TYPE::SRC_NODE) {}
    StreamNode(const std::string& name, const std::string& url) : BaseNode(name, NODE_TYPE::SRC_NODE), stream_url_(url){}
    virtual ~StreamNode() { };

    void set_stream_url(const std::string& stream_url)
    {
        stream_url_ = stream_url;
    }

    void set_skip_frame(int skip_frame)
    {
        if (skip_frame < 1)
        {
            skip_frame = 1;
        }
        skip_frame_ = skip_frame;
    }

    void work() override;

private:
    std::string stream_url_;
    int skip_frame_ = 1;
    int frame_count_ = -1;
};

}

#endif  // STREAMNODE_HPP__